//
// Amicus Serial Terminal Program
//
// Can't paste more that 64K bytes into out going buffer
// A single line can't be more than 4096 bytes
//

unit UnitTerm;

interface

uses
  OneInst,Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls, ToolWin, ExtCtrls, ImgList, mswheel, StrUtils,
  cMMClient, Registry;

type
  TUIState = (itNotConnected, itConnected, itDisConnected);

  TFormTerm = class(TForm)
    MainMenu1: TMainMenu;
    Edit1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    SelectAll1: TMenuItem;
    N1: TMenuItem;
    ClearBuffer1: TMenuItem;
    Transffers1: TMenuItem;
    NewConnection1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    SendTextFile1: TMenuItem;
    ViewTextFile1: TMenuItem;
    N3: TMenuItem;
    Settings2: TMenuItem;
    Connect1: TMenuItem;
    Disconnect1: TMenuItem;
    ToolBar1: TToolBar;
    PopupComPorts: TPopupMenu;
    None1: TMenuItem;
    Com11: TMenuItem;
    Com21: TMenuItem;
    Other1: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton11: TToolButton;
    ImageList1: TImageList;
    TBConnect: TToolButton;
    TBDisconnect: TToolButton;
    TBSettings: TToolButton;
    TBClearBuffer: TToolButton;
    Panel1: TPanel;
    PanelStatus: TPanel;
    Panel3: TPanel;
    PanelRxStatus: TPanel;
    PanelTxStatus: TPanel;
    Timer1: TTimer;
    N5: TMenuItem;
    Print1: TMenuItem;
    PrintDialog1: TPrintDialog;
    S1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Format1: TMenuItem;
    Font1: TMenuItem;
    FontDialog1: TFontDialog;
    OpenDialog1: TOpenDialog;
    ColorDialog1: TColorDialog;
    BackgroundColour1: TMenuItem;
    TerminatewithLFandCR: TMenuItem;
    Memo2: TRichEdit;
    WordWrap1: TMenuItem;
    ToolButton2: TToolButton;
    ResetButton: TToolButton;
    DelayTimer: TTimer;
    Memo1: TRichEdit;
    StayOnTop: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure ClearBuffer1Click(Sender: TObject);
    procedure NewConnection1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBNewConnectionClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Timer1Timer(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Settings2Click(Sender: TObject);
    procedure Connect1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure S1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure SendTextFile1Click(Sender: TObject);
    procedure ViewTextFile1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BackgroundColour1Click(Sender: TObject);
    procedure TerminatewithLFandCRClick(Sender: TObject);
    procedure WordWrap1Click(Sender: TObject);
    procedure ResetButtonClick(Sender: TObject);
    procedure DelayTimerTimer(Sender: TObject);
    Procedure DelayMs(pDelayTime: Integer);
    procedure StayOnTopClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
    myReg: TRegistry;                   // Registry access
    gDevName: array [0..20] of char;    // device name
    CommConfig:TCommConfig;             // comms config structure
    hComm:Thandle;                      // comms handle
    rComm:Thandle;                      // Reset comms handle
    BytesRxed : cardinal;               // byte counts
    BytesTxed : cardinal;
    RxBuffer: array [0..4095] of char;  // TX / RX buffers
    TxBuffer: array [0..4095] of char;

    osRx:TOverLapped;                   // overlapped structures for comms
    osTx:TOverLapped;
    fTxing:Boolean;                     // flag saying we are transmitting
    fWaitingRx:boolean;                 // flag saying we are waiting for rx data
    InTimer:Boolean;                    // re-entrancy flag for timer
    InPaste:Boolean;                    // re-entrancy flag for paste operations
    extra:string;                       // temp buffer for keypresses
    gBufferPosition:integer;            // position in string for incomomg text
    gComPort:       String;
    gBaudrate:   Integer;
    gDataBytes:  Integer;
    gParity:     Integer;
    gStopBits:   Integer;
    //gFlowControl:Integer;

    function SetComProperties(pComName:string; var pCommConfig:TCommConfig):Boolean;
    function Connect(pComName:string; pCommConfig:TCommConfig):boolean;
    procedure SetUI(State : TUIState);
    function AreDisConnected:Boolean;
    procedure UpdateMemo(a : array of char; l : cardinal);
    procedure InitComms;
    procedure FreeComms;
    //Procedure OnPacket(pSender:TObject;pValue:string);
    Procedure OnConnect(pSender:TObject);
    Procedure OnDisconnect(pSender:TObject);
  public
    { Public declarations }
  End;

var
  FormTerm: TFormTerm;
  ComConnected: Boolean;
  gPortName: String;
  WasConnected: Boolean;

const
    ClearBufferImageEmpty = 1;
    ClearBufferImageFull = 2;

implementation

uses
	UnitConnect, ComPortList;

{$R *.DFM}
//-------------------------------------------------------------------------
// The Bootloader has started
// So disconnect the serial port
procedure TFormTerm.OnConnect(pSender:TObject);
Begin
    If ComConnected = True Then 				// Are we connected?
    	Begin
            WasConnected := True;               // Indicate that we were connected before being told to disconnect
            If(gComPort <> 'COM1') Then 		// Is it COM1?
            	Begin                           // No. So...
            		Disconnect1Click(Self);		// Disconnect
                End;
        End
    else
        WasConnected := False;
End;
//-------------------------------------------------------------------------
procedure TFormTerm.OnDisconnect(pSender:TObject);
Begin
    If(WasConnected = True) Then                // Were we connected before being told to disconnect ?
        begin
            Connect1Click(Self);                // Reconnect
        end;
End;
//-------------------------------------------------------------------------
// Capture the data from the CSURV server
{
procedure TFormTerm.OnPacket(pSender:TObject; pValue:string);
Var
    InputString: String;
Begin
    //Memo1.Lines.Add(pValue);
	If (Pos('[loader]',lowercase(pValue)) <> 1) Then Exit; 				// Ignore packets not intended for us
	InputString := AnsiReplaceStr(pValue, '[loader]', ''); 		// Remove the text "[loader]" from the beginning of the line

End;
}
//-------------------------------------------------------------------------
// FormCreate
//-------------------------------------------------------------------------
// Function
//    Set up overlapped structures etc
// Parameters
//    Sender - mandatory (unused)
// Returns
//    None
//-------------------------------------------------------------------------
procedure TFormTerm.FormCreate(Sender: TObject);
Begin
    ComConnected := False;
    hComm :=  INVALID_HANDLE_VALUE;

    // zero byte counts
    BytesTxed := 0;
    BytesRxed := 0;

    // set up overlapped structures for coms
    osRx.Internal := 0;
    osRx.InternalHigh := 0;
    osRx.Offset := 0;
    osRx.OffsetHigh := 0;

    osRx.hEvent := INVALID_HANDLE_VALUE;

    osTx.Internal := 0;
    osTx.InternalHigh := 0;
    osTx.Offset := 0;
    osTx.OffsetHigh := 0;

    osTx.hEvent := INVALID_HANDLE_VALUE;

    // set up flags
    fTxing := false;
    fWaitingRx := false;
    SetUI(itNotConnected);
// events from messaging...
   //MMClient.OnPacket := OnPacket;
   MMClient.OnConnect := OnConnect;
   MMClient.OnDisconnect := OnDisconnect;
End;
//-------------------------------------------------------------------------
// Form Activate
//-------------------------------------------------------------------------
// Read the FONT information from the registry
//-------------------------------------------------------------------------
procedure TFormTerm.FormActivate(Sender: TObject);
var
    Bold: Boolean;
    Italic: Boolean;
Begin
    OnActivate := NIL;
//
// Load or Create values from the registry
//
    myReg := TRegistry.Create;
    myReg.RootKey := HKEY_LOCAL_MACHINE;                                                // Point to the correct root
    If myReg.OpenKey('Software\Crownhill\Amicus18\Terminal', false) then                // Does the registry entry already exist?
        Begin                                                                           // Yes. So read from it
Try
            FormTerm.Height := myReg.ReadInteger('FormHeight');
            FormTerm.Width := myReg.ReadInteger('FormWidth');
            FormTerm.Top := myReg.ReadInteger('FormTop');
            FormTerm.Left := myReg.ReadInteger('FormLeft');
            gComPort   := myReg.ReadString('PortCom');
            gPortName  := myReg.ReadString('PortName');
            gBaudrate  := myReg.ReadInteger('Baud');
            gDataBytes := myReg.ReadInteger('DataBytes');
            gParity  := myReg.ReadInteger('Parity');
            gStopBits  := myReg.ReadInteger('StopBits');
            //gFlowControl := myReg.ReadInteger('Flow');
            TerminatewithLFandCR.Checked := myReg.Readbool('Terminate');
            WordWrap1.Checked := myReg.Readbool('WordWrap');
            StayOnTop.Checked := myReg.Readbool('StayOnTop');
Except
End;
        End
    Else                                                                                // Otherwise... Create default values
        Begin
            myReg.OpenKey('Software\Crownhill\Amicus18\Terminal', true);                // Create a registry entry If it's not already there
            FormTerm.FormStyle := fsNormal;
            gComPort :=  'COM1';
            gPortName := 'Communications Port';
            gBaudrate := CBR_9600;
            gDataBytes:= 8;
            gParity := NOPARITY;
            gStopBits := ONESTOPBIT;
            FormTerm.Left := 626;
            FormTerm.Height := 413;
            FormTerm.Top := 409;
            FormTerm.Width := 605;
            myReg.WriteInteger('FormHeight',FormTerm.Height);
            myReg.WriteInteger('FormWidth',FormTerm.Width);
            myReg.WriteInteger('FormTop',FormTerm.Top);
            myReg.WriteInteger('FormLeft',FormTerm.Left);
            myReg.WriteString('PortCom',gComPort);
            myReg.WriteString('PortName',gPortName);
            myReg.WriteInteger('Baud',gBaudrate);
  	        myReg.WriteInteger('DataBytes',gDataBytes);
            myReg.WriteInteger('Parity',gParity);
            myReg.WriteInteger('StopBits',gStopBits);
            //myReg.WriteInteger('Flow',gFlowControl);
            myReg.Writebool('Terminate',true);
            TerminatewithLFandCR.Checked := false;
            //
            // Write the default font details to the registry
            //
            myReg.WriteInteger('FontCharset',ANSI_CHARSET);
            myReg.WriteInteger('FontColour',clYellow);
            myReg.WriteInteger('FontHeight',-11);
            myReg.WriteString('FontName','Fixedsys');
            myReg.WriteInteger('FontSize',8);
            myReg.Writebool('Bold',False);
            myReg.Writebool('Italic',False);
            myReg.Writebool('WordWrap',False);
            //
            // Write the default background color to the registry
            //
            myReg.WriteInteger('Back_Colour',clNavy);
            WordWrap1.Checked := myReg.Readbool('WordWrap');
            myReg.Writebool('StayOnTop',False);
        End;
//
// Set the Background color, read from the registry
//
    Memo1.Color := myReg.ReadInteger('Back_Colour');
    //
    // Set the Font used, read from the registry
    //
    Bold := myReg.Readbool('Bold');
    Italic := myReg.Readbool('Italic');

    If Bold Then Memo1.Font.Style := [fsBold];
    If Italic Then Memo1.Font.Style := [fsItalic];
    If Bold and Italic Then Memo1.Font.Style := [fsItalic,fsBold];

    Memo1.Font.Charset := myReg.ReadInteger('FontCharset');
    Memo1.Font.Color := myReg.ReadInteger('FontColour');
    Memo1.Font.Height := myReg.ReadInteger('FontHeight');
    Memo1.Font.Name := myReg.ReadString('FontName');
    Memo1.Font.Size := myReg.ReadInteger('FontSize');
    Memo1.WordWrap := WordWrap1.Checked;
    Memo1.Clear();
End;
//---------------------------------------------------------------------------------
// Main Form On Paint Event
// Alter the Form Style
procedure TFormTerm.FormPaint(Sender: TObject);
begin
    If(StayOnTop.Checked = true) then
        FormTerm.FormStyle := fsStayOnTop
    else
        FormTerm.FormStyle := fsNormal;
end;
//-------------------------------------------------------------------------
procedure TFormTerm.TerminatewithLFandCRClick(Sender: TObject);
Begin
    myReg.Writebool('Terminate',TerminatewithLFandCR.Checked);
End;
//-------------------------------------------------------------------------
// Exit
//-------------------------------------------------------------------------
// Function
//    Close Program
// Parameters
//    Sender - manadory (unused)
// Returns
//    None
//-------------------------------------------------------------------------
procedure TFormTerm.Exit1Click(Sender: TObject);
Begin
  	close;
End;

//-------------------------------------------------------------------------
// FormClose
//-------------------------------------------------------------------------
// Function
//    Called when Program closing, free handles If open
// Parameters
//    Sender - manadory (unused)
// Returns
//    None
procedure TFormTerm.FormClose(Sender: TObject; var Action: TCloseAction);
Begin
    If Not AreDisConnected() Then
        Action := caNone
    Else
    Begin
        Timer1.Enabled := False;
    End;

    If hComm <> INVALID_HANDLE_VALUE Then CloseHandle(hComm);
    If osTx.hEvent <> INVALID_HANDLE_VALUE Then closeHandle(osRx.hEvent);
    If osTx.hEvent <> INVALID_HANDLE_VALUE Then closeHandle(osTx.hEvent);

  	myReg.WriteInteger('Baud',gBaudrate);
  	myReg.WriteInteger('DataBytes',gDataBytes);
    myReg.WriteInteger('Parity',gParity);
    myReg.WriteInteger('StopBits',gStopBits);
    //myReg.WriteInteger('Flow',FLOWCONTROL);

    myReg.WriteInteger('FormHeight',FormTerm.Height);
    myReg.WriteInteger('FormWidth',FormTerm.Width);
    myReg.WriteInteger('FormTop',FormTerm.Top);
    myReg.WriteInteger('FormLeft',FormTerm.Left);
  	myReg.Free;
End;

//-------------------------------------------------------------------------
// Open/Close COm Port
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
// InitComms
//-------------------------------------------------------------------------
// Function
//     Initialise coms, reset bytes rxed/rxed and overlapped structures
// Parameters
//     None
// Returns
//    None
procedure TFormTerm.InitComms;
Begin
    BytesTxed := 0;
    BytesRxed := 0;

    // overlapped structure for reciever
    osRx.Internal := 0;
    osRx.InternalHigh := 0;
    osRx.Offset := 0;
    osRx.OffsetHigh := 0;

    osRx.hEvent := CreateEvent(nil, TRUE, FALSE, nil);

    // overlapped structure for transmitter
    osTx.Internal := 0;
    osTx.InternalHigh := 0;
    osTx.Offset := 0;
    osTx.OffsetHigh := 0;

    osTx.hEvent := CreateEvent(nil, TRUE, FALSE, nil);

    // Flags for overlapped state
    fTxing := false;
    fWaitingRx := false;

    // position in incoming text buffer
    gBufferPosition := 1;
End;

//-------------------------------------------------------------------------
// FreeComms
//-------------------------------------------------------------------------
// Function
//     Release and reset handles
// Parameters
//     None
// Returns
//    None
procedure TFormTerm.FreeComms;
Begin
      If hComm <> INVALID_HANDLE_VALUE Then
      Begin
          // release coms port
          CloseHandle(hComm);
          // release overlapped structure events
          If osTx.hEvent <> INVALID_HANDLE_VALUE Then closeHandle(osRx.hEvent);
          If osTx.hEvent <> INVALID_HANDLE_VALUE Then closeHandle(osTx.hEvent);
          // reset handles
          hComm := INVALID_HANDLE_VALUE;
          osTx.hEvent := INVALID_HANDLE_VALUE;
          osTx.hEvent := INVALID_HANDLE_VALUE;
      End;
      // If we are disconnected, tell the user about it
      If hComm = INVALID_HANDLE_VALUE Then  SetUI(itDisConnected);

End;

//-------------------------------------------------------------------------
// SetUI
//-------------------------------------------------------------------------
// Function
//     Sets User Interface depending on state connected or not connected
// Parameters
//     State : TUIState
// Returns
//    None
procedure TFormTerm.SetUI(State : TUIState);
Begin
     // sort buttons on UI out
     case State of
     itConnected :
     Begin
          DisConnect1.Enabled := true;
          TBDisconnect.Enabled := true;
          Connect1.Enabled := False;
          TBConnect.Enabled := False;
          Settings2.Enabled := true;
          TBsettings.Enabled := true;
          ComConnected := True;
     End;

     // we have a connection but now its gone
     itDisConnected :
     Begin
          DisConnect1.Enabled := False;
          TBDisconnect.Enabled := False;
          Connect1.Enabled := True;
          TBConnect.Enabled := True;
          Settings2.Enabled := true;
          TBsettings.Enabled := True;
          ComConnected := False;
     End;

     // we have never had a connection, so we can't change properties
     itNotConnected :
     Begin
          DisConnect1.Enabled := False;
          TBDisconnect.Enabled := False;
          Connect1.Enabled := False;
          TBConnect.Enabled := False;
          Settings2.Enabled := False;
          TBsettings.Enabled := False;
          ComConnected := False;
     End;

     End; // case
End;
//-------------------------------------------------------------------------
// Connect
//-------------------------------------------------------------------------
// Function
//     Open the port and set up the port properties
// Parameters
//    pComName : Name of port
// Returns
//    None
function TFormTerm.Connect(pComName:string; pCommConfig:TCommConfig):Boolean;
var
  s:string;
  LDevName: array [0..20] of char;
  ComTimeOuts:TCOMMTIMEOUTS;
Begin
   ComConnected := False;
   // If we already have a comm port open close it
   If hComm <>  INVALID_HANDLE_VALUE then
   Begin
      Timer1.Enabled := False;
      freeComms();
   End;

   // make a com name of the form Com1:
   strPCopy(@gDevName, pComName);

   // make a device name, as we need a device name to open com9 and above
   s := '\\.\'+pComName;
   strPCopy(@LdevName, s);

   // Open the comm port;
   hComm := CreateFile( LDevName
               , GENERIC_READ or GENERIC_WRITE
               , 0
               , nil
               , OPEN_EXISTING
               , FILE_FLAG_OVERLAPPED
               ,0
               );

    // If we have a handle
    If hComm <>  INVALID_HANDLE_VALUE Then
    Begin
        // set up com port properties, previously sorted out by a call
        // to the ports property page dialogue
        SetCommConfig(hComm, pCommConfig, sizeof(pCommConfig));

        // set the timeouts, so we don't hang around
        If  GetCommTimeouts(hComm, ComTimeOuts) then
        Begin
                ComTimeOuts.ReadIntervalTimeout := 0;
                ComTimeOuts.ReadTotalTimeoutMultiplier := 0;
                ComTimeOuts.ReadTotalTimeoutConstant := 50;
                SetCommTimeOuts(hComm, ComTimeOuts);
        End;

        // initialise overlapped structures, byte counters etc
        InitComms();
        PanelRxStatus.caption := ' Bytes Rxed : 0';
        PanelTxStatus.caption := ' Bytes Txed : 0';
        PanelStatus.caption := 'Connected to ' + gDevName + ' at ' + IntToStr(gBaudrate) + ' baud';
        // ensure we will be able to transmit data
        Memo2.Lines.BeginUpdate();
        Memo2.Clear();
        Memo2.Lines.EndUpdate();

        // switch on reciever
        Timer1.Enabled := true;
        InTimer := false;
        InPaste := false;
        extra := '';
        Result := true;
    End
    Else
    Begin
        // not connected, reset captions
        PanelRxStatus.caption := '';
        PanelTxStatus.caption := '';
        PanelStatus.caption := 'Not Connected';
        Result := False;
    End;

    ComConnected := Result;
End;

//-------------------------------------------------------------------------
// IfConnecedDisConnect
//-------------------------------------------------------------------------
// Function
//     If we are engaged in a conversation, disconnect us
// Parameters
//    None
// Returns
//    None
function TFormTerm.AreDisConnected:Boolean;
Begin
   	If hComm <> INVALID_HANDLE_VALUE Then
   		Begin
        //If MessageDlg('Disconnect from ' + gDevName, mtInformation, [mbYes, mbNo], 0) = mrYes Then
        //Begin
           Timer1.Enabled := False;
           FreeComms();
           Result := True;
        //End
        //Else
        //   Result := False;
   	End
   Else
       Result := True;
End;

//-------------------------------------------------------------------------
// NewConnection1Click
//-------------------------------------------------------------------------
// Function
//     some one selected new connection from menu
//     validate com port
//     set comm prorties with vendor supplied dialog
//     connect to com port
// Parameters
//     Sender - mandatory (unused)
// Returns
//    None
procedure TFormTerm.NewConnection1Click(Sender: TObject);
var
   	Connected : Boolean;
   	pComName:string;
   	ReturnResult : TModalResult;
   	ComList: TStringList;
    AmountOfPorts: Integer;
    Index: Integer;
    ParseList: TStringList;
    ComText: String;
    ComPortList: TStringList;
Begin
   	ComList := TStringList.Create;
    ParseList := TStringList.Create;
    ComPortList := TStringList.Create;
    ReturnResult := MrCancel;
    If AreDisConnected() Then
   	    Begin
   		    AmountOfPorts := ListComPorts(ComList);  	// Find the amount of com ports available and their details
       	    Connected := False;

       	    with TFormConnect.Create(Application) as TFormConnect do
       	        Begin
                Try
                    Combobox1.Text := gComPort + ' (' + gPortName + ')';                // Place the last com port as the text in the combo box
                    For Index := 0 to AmountOfPorts - 1 do
            	        Begin
                            ComText := ComList[Index];			                        // Extract a com listing from the stringlist
            		        ParseList.CommaText := ComText;                             // Parse it
                	        ComPortList.Add(ParseList[0] + ' (' + ParseList[1] + ')');	// Fill the Combobox with the Com ports available
            	        End;
                    Combobox1.Items := ComPortList;		                                // Fill the Combobox with the Com ports available
          	        ReturnResult := ShowModal;
                    //
                    // Get the Com port number from the ComPortList
                    //
                    Index := Pos(' ', Combobox1.Text);			                        // Find the location of the first space
                    pComName := LeftStr(Combobox1.Text,Index);
                    pComName := Trim(pComName);
                    gPortName := RightStr(Combobox1.Text, Length(Combobox1.Text) - Index);
                    gPortName := AnsiReplaceStr(gPortName,'(','');
                    gPortName := AnsiReplaceStr(gPortName,')','');
                    gPortName := Trim(gPortName);
                    gComPort := pComName;
          	        myReg.WriteString('PortCom',pComName);                              // Com number text: com1, com2 etc...
                    myReg.WriteString('PortName',gPortName);                            // Com Name text: "Amicus18 Serial Port", "Serial Port" etc
          	    Finally
          	    free;
         	    End;
        End;

    //Memo1.Lines.Add('ReturnResult = ' + IntToStr(ReturnResult));
    If ReturnResult = MrOk Then
        Begin
            //
            // Set CommConfig to defaults
            //
            FillChar(CommConfig, sizeof(CommConfig), 0);
            CommConfig.dwsize := sizeof(CommConfig);
            CommConfig.wVersion := 1;
            GetCommState(hComm, CommConfig.dcb);
            CommConfig.dwProviderSubType  := PST_RS232;
            CommConfig.dwProviderSize := 1;
            //
            // Set the default Baudrate, byte size etc for the config window
            //
            CommConfig.dcb.Baudrate  := gBaudrate;
            CommConfig.dcb.ByteSize  := gDataBytes;
            CommConfig.dcb.Parity    := NOPARITY;
            CommConfig.dcb.StopBits  := gStopBits;
            // open the port
            If Connect(pComName, CommConfig) Then Connected := True
        End;
//
// set up user buttons If sucessful
// or raise dialog If port not avaliable
//
    If(Connected = true) Then
        Begin
            SetUI(itConnected);
        End
    Else If ReturnResult = mrOk Then
        Begin
            MessageDlg('Failed to connect to ' + pComName, mtInformation, [mbOK], 0);
            SetUI(itNotConnected);
        End;
    End;
    ComList.Free;
    ParseList.Free;
    ComPortList.Free;
End;
//-------------------------------------------------------------------------
// TBNewConnectionClick
//-------------------------------------------------------------------------
// Function
//     some one selected new connection from tool bar
//     Can chose from drop down or call a dialogue
//     connect to com port
// Parameters
//     Sender - mandatory (unused)
// Returns
//    None
procedure TFormTerm.TBNewConnectionClick(Sender: TObject);
var
   pComName:string;
Begin
   // Work out com port name
   // and If selection a valid name
   //
   With Sender as TMenuItem Do 
   Begin
       // If we have a valid connection
       //
       case tag of
       // None selected - offer to dump current connection
       0: AreDisconnected();

       // Coms 1 to 8 are offered as menu items
       1,2,3,4,5,6,7,8:
       Begin
           // get new comm port name
           pComName := 'COM' + inttostr(tag);
           gComPort := pComName;
           myReg.WriteString('PortCom',pComName);
           // dump existing connection If active
           If AreDisconnected() Then
           Begin
              // set up port properties, by calling proprty page dialogue
              If SetComProperties(pComName, CommConfig) then
              Begin
                  // open port and set up buttons etc
                  If Connect(pComName, CommConfig) Then
                        SetUI(itConnected)
                  Else
                  Begin
                        MessageDlg('Failed to connect to ' + pComName, mtInformation, [mbOK], 0);
                        SetUI(itNotConnected);
                  End;
              End;
           End;
       End
       //
       // Other.. selected so
       // Call NewConnection dialogue
       Else
          NewConnection1Click(Sender);
   End;
   End;
End;
//-------------------------------------------------------------------------
// Connect
//-------------------------------------------------------------------------
// Function
//     Connect to current com port
// Parameters
//     None
// Returns
//    None
procedure TFormTerm.Connect1Click(Sender: TObject);
Begin
    If Connect(gDevName, CommConfig) Then
        Begin
    		SetUI(itConnected);
            ComConnected := True;
    	End
    Else
    	Begin
          	MessageDlg('Failed to connect to ' + gDevName, mtInformation, [mbOK], 0);
          	SetUI(itNotConnected);
            ComConnected := False;
    	End;
End;


//-------------------------------------------------------------------------
// DisConnect
//-------------------------------------------------------------------------
// Function
//     Close the port and set up the port properties
// Parameters
//    pComName : Name of port
// Returns
//    None
//-------------------------------------------------------------------------
procedure TFormTerm.Disconnect1Click(Sender: TObject);
Begin
     PanelStatus.caption := 'Not Connected';
     Timer1.Enabled := False;
     FreeComms();
     ComConnected := False;
End;

//-------------------------------------------------------------------------
// Coms Setup
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
// SetComProperties
//-------------------------------------------------------------------------
// Function
//    Determines If the com port is a valid com port
//    Raises property dialogue for it
// Parameters
//    pComName : Name of port
// Returns
//    None
Function TFormTerm.SetComProperties(pComName:string; var pCommConfig:tCommConfig):Boolean;
Begin
   // Set CommConfig to defaults
   //
   FillChar(pCommConfig, sizeof(pCommConfig), 0);
   pCommConfig.dwsize := sizeof(pCommConfig);
   pCommConfig.wVersion := 1;
   GetCommState(hComm, pCommConfig.dcb);
   pCommConfig.dwProviderSubType  := PST_RS232;
   pCommConfig.dwProviderSize := 1;

//
// Set the default Baudrate, byte size etc for the config window
//
   pCommConfig.dcb.Baudrate  := gBaudrate;
   pCommConfig.dcb.ByteSize  := gDataBytes;
   pCommConfig.dcb.Parity    := NOPARITY;
   pCommConfig.dcb.StopBits  := gStopBits;
   //
   // Open the property dialog for selected comm port
   //
   If CommConfigDialog(@pComName[1], Handle , pCommConfig) Then
        Begin
        Result := True;
        gBaudrate  := pCommConfig.dcb.Baudrate;
        gDataBytes := pCommConfig.dcb.ByteSize;
        gParity    := pCommConfig.dcb.Parity;
        gStopBits  := pCommConfig.dcb.StopBits;
        myReg.WriteInteger('Baud',gBaudrate);
  	    myReg.WriteInteger('DataBytes',gDataBytes);
        myReg.WriteInteger('Parity',gParity);
        myReg.WriteInteger('StopBits',gStopBits);
        End
   Else
        Result := False;
End;

//-------------------------------------------------------------------------
// Settings2
//-------------------------------------------------------------------------
// Function
//   Change com settings
//
// Parameters
//    Sender - mandatory
//    Kye    - Key pressed
// Returns
//    None
procedure TFormTerm.Settings2Click(Sender: TObject);
Begin
   If hComm <> INVALID_HANDLE_VALUE Then
   Begin
        // change settings, disconnect and reconnect to kick coms
        FreeComms();
        SetComProperties(gDevName, CommConfig);
        If Connect(gDevName, CommConfig) Then
              SetUI(itConnected)
        Else
        Begin
              MessageDlg('Failed to connect to ' + gDevName, mtInformation, [mbOK], 0);
              SetUI(itNotConnected);
        End;
   End
   Else
   Begin
        SetComProperties(gDevName, CommConfig);
   End
End;


//-------------------------------------------------------------------------
// TRANSMITTING / RECIEVING
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
// FormKeyPress
//-------------------------------------------------------------------------
// Function
//   If conncted to com port, write this char to it
//
// Parameters
//    Sender - mandatory
//    Kye    - Key pressed
// Returns
//    None
procedure TFormTerm.FormKeyPress(Sender: TObject; var Key: Char);
Begin
     TBClearBuffer.ImageIndex := ClearBufferImageFull;      // Change Trash image to Full
     
     // If the port isn't open, forget it
     If hComm = INVALID_HANDLE_VALUE  Then exit;

     // If we trying to stuff keys into memo, the queue up the extra until we finish
     If InPaste Then
     Begin
        extra := extra + key;
        exit;
     End;
     InPaste := True;

     // add the key pressed to the End of the outgoing text
     // the timer will deal with transmitting it
     Memo2.Lines.BeginUpdate();
     If Memo2.Lines.count > 0 then
        Memo2.Lines[Memo2.Lines.count-1] := Memo2.Lines[Memo2.Lines.count-1] + extra + key
     Else
        Memo2.Lines.add(extra+key);

     extra := '';
     Memo2.Lines.EndUpdate();
     InPaste := False;
End;

//-------------------------------------------------------------------------
// Send Text File
//-------------------------------------------------------------------------
// Function
//   Dumps a text file into out going buffer
//
// Parameters
//    Sender - mandatory
//    Kye    - Key pressed
// Returns
//    None
procedure TFormTerm.SendTextFile1Click(Sender: TObject);
Begin
   // find file to open
   If OpenDialog1.execute then
   Begin
     SendTextFile1.Enabled := false;
     InPaste := true;
     // stuff file contents into Memo2
     // timer deals with transmitting it
     Memo2.Lines.beginUpdate();
     Memo2.Lines.LoadFromFile(Opendialog1.FileName);
     Memo2.Lines.EndUpdate();
     InPaste := false;
   End;
End;

//-------------------------------------------------------------------------
// UpdateMemo
//-------------------------------------------------------------------------
// Function
//    Interperit incoming text as simple telnet terminal
// Parameters
//    Sender - mandatory
//    Key    - Key pressed
// Returns
//    None
procedure TFormTerm.UpdateMemo(a : array of char; l : cardinal);
var
  c:char;
  s2:string;
  i:integer;
  sl:TstringList;
Begin
    BytesRxed := BytesRxed + l;
    If(BytesRxed > 0) Then
        Begin
            TBClearBuffer.ImageIndex := ClearBufferImageFull;      // Change Trash image to Full
        End;

   // fetch last line from memo box
   Memo1.Lines.BeginUpdate();
   If Memo1.Lines.Count > 0 then
      s2 := Memo1.Lines[Memo1.lines.count - 1]
   Else
      s2 := '';
   // create a temporary string list to work in
   SL := TStringList.Create;

   for i := 0 to l-1 do
   Begin
      c := a[i];
      // If <1> Then clear the buffer
      If c = #1 then
        ClearBuffer1Click(Self)
      // If <CR> add a new line
      Else If c = #13 then
      Begin
          SL.Add(s2);
          s2 := '';
          gBufferPosition := 1;
      End
      // If <LF> reset position to start of current line
      Else If c = #10 then
        gBufferPosition := 1
      // If <BS> delete appropriate character
      Else If c = #8 then
      Begin
         If gBufferPosition > 1 then
         Begin
           dec(gBufferPosition);
           delete(s2,gBufferPosition,1);
         End;
      End
      // If <DLE> delete
      Else If c = #16 then
      Begin
         If gBufferPosition > 1 then
         Begin
           delete(s2,gBufferPosition,1);
           dec(gBufferPosition);
         End;
      End
      // If a valid character add it to the text
      Else If c in [' '..'~', chr(9)] then
      Begin
          If gBufferPosition < length(s2) Then
               insert(c, s2, gBufferPosition)
          Else
               s2 := s2 + c;
          inc(gBufferPosition);
      End;
   End;
   SL.Add(s2);
   application.processmessages();

   // If the memo has text in it, change the last line
   If Memo1.Lines.Count > 0 then
   Begin
      Memo1.Lines[Memo1.Lines.Count-1] :=  SL.Strings[0];
      SL.Delete(0);
   End;

   // add remaining strings to memo
   Memo1.Lines.AddStrings(SL);
   Memo1.Lines.EndUpdate();
   // throw away tempory string list
   SL.Free;

   // move memo to bottom
   Memo1.SetFocus;
   Memo1.selstart := length(Memo1.Text)-1;

   // update number of bytes recieved
   PanelRxStatus.caption := ' Bytes Rxed :' + inttostr(BytesRxed);
   PanelRxStatus.refresh;

End;
//-------------------------------------------------------------------------
// Timer1Timer
//-------------------------------------------------------------------------
// Function
//     unload recieved chars into display
//     puump data into txmitter
// Parameters
//    None
// Returns
//    None
procedure TFormTerm.Timer1Timer(Sender: TObject);
const
   ARBSIZE = 32;
var
    Ret:Boolean;
    BytesRead:cardinal;
    s:string;
    BytesWritten:cardinal;
    dwRet, l:cardinal;
    err:integer;
Begin
    If hComm = INVALID_HANDLE_VALUE Then exit;

    // check re-entrancy
    If InTimer Then exit;
    InTimer := true;

    Timer1.Enabled := False;

    // deal with recieve data

    // If we are waiting for a previous read to complete
    If fWaitingRx Then
    Begin
        // see If its done
        dwRet := WaitForSingleObject(osRx.hEvent, 10);

        If dwRet = WAIT_OBJECT_0 then
        Begin
          If GetOverlappedResult(hComm, osRx, BytesRead, FALSE) Then
          Begin
              // read the incoming characters and update the display
              If (BytesRead > 0) Then UpdateMemo(Rxbuffer, BytesRead);
              // flag we are no longer waiting
              fWaitingRx := False;
          End
       End
    End;

    If Not fWaitingRx Then
    Begin
        // wait for imcoming coms
        Ret := ReadFile( hComm, RxBuffer, 4096, BytesRead, @osRx);

        // If we get some data update the display
        If Ret and (bytesRead > 0) Then
        Begin
            UpdateMemo(Rxbuffer, BytesRead);
        End
        Else
        Begin
            err := getLastError;

            If err = ERROR_IO_PENDING Then
            Begin
                // flag we are waiting for coms for the next time round
                fWaitingRX := True;
            End;
        End;
    End;

    // deal with transmit data

    // If we are already transmitting
    If (fTxing) Then
    Begin
        // wait for the previous lot of data send to able off
        dwRet := WaitForSingleObject(osTx.hEvent, 10);

        If dwRet = WAIT_OBJECT_0 then
        Begin
          If GetOverlappedResult(hComm, osTx, BytesWritten, FALSE) Then
          Begin
              // we sent this data, add it to bytes sent
              BytesTxed := BytesTxed  + bytesWritten;
              If(BytesTxed > 0) Then
                Begin
                    TBClearBuffer.ImageIndex := ClearBufferImageFull;      // Change Trash image to Full
                End;
              PanelTxStatus.caption := ' Bytes Txed : ' + inttostr(BytesTxed);
              // we can now send more
              fTxing := false;
          End;
        End;
    End;

    // If we aren't transmitting and there is data to send and its not changing
    If (Not fTxing) and (Memo2.lines.Count > 0) and (not InPaste) then
    Begin
         // get the next line of info to go out of the buffer
         // If theres only one line left don't send a CR LF
         If Memo2.Lines.count > 1 Then
            If(TerminatewithLFandCR.Checked = True) Then
            	s :=  Memo2.Lines[0] + #10 + #13
            Else
            	s :=  Memo2.Lines[0] + #13
         Else
            s :=  Memo2.Lines[0];

         // copy the line (or 4096  bytes) out to the com port
         strplcopy(txbuffer, s, 4096);

         If length(s) <= 4096 then
            l := length(s)
         Else
            l := 4096;

         // send the line over the coms port
         Ret := writeFile(hComm, txbuffer, l, BytesWritten, @osTx);
         // remove the line we've done with it
         Memo2.Lines.Delete(0);

         If Ret then
         Begin
            // If we managed to send the data then update the
            // bytes transmitted and leave the ftxing flag clear
            BytesTxed := BytesTxed + BytesWritten;
            If(BytesTxed > 0) Then
                Begin
                    TBClearBuffer.ImageIndex := ClearBufferImageFull;      // Change Trash image to Full
                End;
            PanelTxStatus.caption := ' Bytes Txed : ' + inttostr(BytesTxed);
         End
         Else
         Begin
            // If we are waiting for IO to complete then falg this
            // and we'll check If its done on the next timer
            err := getLastError;
            If err = ERROR_IO_PENDING Then fTxing := true;
         End;
    End;

    // If the outgoing memo box is empty, allow the user to send a file
    If (Memo2.Lines.Count = 0) and not fTxing Then
    Begin
        SendTextFile1.Enabled := true;
    End;

    // clear the re-entrancy flag
    InTimer := False;
    Timer1.Enabled := true;
End;


//-------------------------------------------------------------------------
// Editing
//-------------------------------------------------------------------------

procedure TFormTerm.Copy1Click(Sender: TObject);
Begin
Try
   If (Memo1.Lines.Count > 0) and (Memo1.SelLength > 0) then  Memo1.CopyToClipBoard;
Finally
End;
End;
//-------------------------------------------------------------------------
procedure TFormTerm.SelectAll1Click(Sender: TObject);
Begin
Try
    Memo1.SelectAll;
Finally
End;
End;
//-------------------------------------------------------------------------
procedure TFormTerm.Paste1Click(Sender: TObject);
Begin
   // paste the clipboard into Memo2 and the timer transmits it
    If InPaste Then exit;
    InPaste := True;
    Memo2.Lines.BeginUpdate();
    Memo2.PastefromClipBoard;
    Memo2.Lines.EndUpdate();
    InPaste := false;
End;

//-------------------------------------------------------------------------
procedure TFormTerm.ClearBuffer1Click(Sender: TObject);
Begin
    TBClearBuffer.ImageIndex := ClearBufferImageEmpty;      // Change Trash image to Empty
    PanelTxStatus.caption := ' Bytes Txed : ';
    PanelRxStatus.caption := ' Bytes Rxed : ';
    Memo1.Lines.Clear;
    BytesTxed := 0;
    BytesRxed := 0;
    gBufferPosition := 1;
End;

//-------------------------------------------------------------------------
procedure TFormTerm.ViewTextFile1Click(Sender: TObject);
Begin
    If OpenDialog1.execute then
    Begin
        Memo1.Lines.LoadFromFile(Opendialog1.FileName);
        gBufferPosition := 1;
    End;
End;

//-------------------------------------------------------------------------
// Print
//-------------------------------------------------------------------------
procedure TFormTerm.Print1Click(Sender: TObject);
Begin
    If PrintDialog1.Execute Then Memo1.Print('Captured from ' + StrPas(gDevName));
End;

//-------------------------------------------------------------------------
// Save to file
//-------------------------------------------------------------------------
procedure TFormTerm.S1Click(Sender: TObject);
Begin
    If SaveDialog1.Execute Then
    Begin
        Memo1.Lines.SaveToFile( SaveDialog1.FileName);
    End;
End;

//-------------------------------------------------------------------------
// Formatting
//-------------------------------------------------------------------------
procedure TFormTerm.Font1Click(Sender: TObject);
var
    Bold: Boolean;
    Italic: Boolean;
Begin
    Bold := False;
    Italic := False;
//
// Set the Font defualt values for the dialog
//
    FontDialog1.Font.Charset := myReg.ReadInteger('FontCharset');
    FontDialog1.Font.Color := myReg.ReadInteger('FontColour');
    FontDialog1.Font.Height := myReg.ReadInteger('FontHeight');
    FontDialog1.Font.Name := myReg.ReadString('FontName');
    FontDialog1.Font.Size := myReg.ReadInteger('FontSize');

    If FontDialog1.execute() Then
        Begin
            Memo1.Font := FontDialog1.Font;
            //
            // Write the font details to the registry
            //
            myReg.WriteInteger('FontCharset',FontDialog1.Font.Charset);
            myReg.WriteInteger('FontColour',FontDialog1.Font.Color);
            myReg.WriteInteger('FontHeight',FontDialog1.Font.Height);
            myReg.WriteString('FontName',FontDialog1.Font.Name);
            myReg.WriteInteger('FontSize',FontDialog1.Font.Size);
            //
            // Get the Font Style and write it to the registry
            //
            If fsBold in FontDialog1.Font.Style then Bold := True;
            If fsItalic in FontDialog1.Font.Style then Italic := True;

            myReg.Writebool('Bold',Bold);
            myReg.Writebool('Italic',Italic);
        End;
End;
//-------------------------------------------------------------------------
// Background Colour Menu option
procedure TFormTerm.BackgroundColour1Click(Sender: TObject);
Begin
    //
    // Set the current color before entering the dialog
    //
    ColorDialog1.Color := myReg.ReadInteger('Back_Colour');

    If ColorDialog1.execute() Then
        Begin
            Memo1.Color := ColorDialog1.Color;
            myReg.WriteInteger('Back_Colour',ColorDialog1.Color);
        End;
End;
//-------------------------------------------------------------------------
// Word Wrap enable/disable
procedure TFormTerm.WordWrap1Click(Sender: TObject);
Begin
	Memo1.WordWrap := WordWrap1.Checked;
    myReg.WriteBool('WordWrap',WordWrap1.Checked);
End;
//-------------------------------------------------------------------------
// Reset Button Pressed
procedure TFormTerm.ResetButtonClick(Sender: TObject);
var
    s: string;
    LDevName: array [0..20] of char;
Begin
//
// Locate the Amicus18 board and connect to it with the current settings (if possible)
//
    LocateComPorts();                                                       // Locate the Amicus18 COM port (if it's connected)
    If((ComConnected = false) or (gComPort <> AmicusPort))Then              // Are we already connected to the amicus board?
   	    Begin                                                               // No. So...
            try
            // make a com name of the form COMn:
            strPCopy(@gDevName, AmicusPort);
            // make a device name, as we need a it to open com9 and above
            s := '\\.\' + AmicusPort;
            strPCopy(@LdevName, s);
            //
            // Open a com port for the Amicus18;
            //
            rComm := CreateFile( LDevName
                                , GENERIC_READ or GENERIC_WRITE
                                , 0
                                , nil
                                , OPEN_EXISTING
                                , FILE_FLAG_OVERLAPPED
                                ,0
                                );

            // If we have a handle
            If rComm = INVALID_HANDLE_VALUE Then
                //MessageDlg('Failed to connect to ' + AmicusPort, mtInformation, [mbOK], 0)
            else
                Begin
                    //Memo1.Lines.Add('Com ' + AmicusPort + ' Open');
                    //
                    // Strobe DTR LOW-HIGH-LOW
                    //
                    EscapeCommFunction(rComm, CLRDTR);
                    DelayMs(20);
                    EscapeCommFunction(rComm, SETDTR);
                    Memo1.Lines.Add(#13 + #10 + 'Amicus18 Board Reset' + #13 + #10);
                    TBClearBuffer.ImageIndex := ClearBufferImageFull;      // Change Trash image to Full
                    DelayMs(20);
                    EscapeCommFunction(rComm, CLRDTR);

                    //Memo1.Lines.Add('Com Closed');
                    // Release the com port
                    CloseHandle(rComm);
                    rComm := INVALID_HANDLE_VALUE;
                End;
            except
            end;
        End
    Else                                                                // Otherwise...
        Begin
            //
            // Strobe DTR LOW-HIGH-LOW
            //
            try
            EscapeCommFunction(hComm, CLRDTR);
            DelayMs(20);
            EscapeCommFunction(hComm, SETDTR);
            Memo1.Lines.Add(#13 + #10 + 'Amicus18 Board Reset' + #13 + #10);
            TBClearBuffer.ImageIndex := ClearBufferImageFull;      // Change Trash image to Full
            DelayMs(20);
            EscapeCommFunction(hComm, CLRDTR);
            except
            end;
        End;
end;
//-------------------------------------------------------------------------
// Delay Timer event
procedure TFormTerm.DelayTimerTimer(Sender: TObject);
begin
    DelayTimer.Enabled := False;
end;
//---------------------------------------------------------------------------------
// Delay for n Milliseconds
Procedure TFormTerm.DelayMs(pDelayTime: Integer);
Var
	SentOK: Dword;
Begin
	DelayTimer.Interval := pDelayTime;
    Application.ProcessMessages;
    DelayTimer.Enabled := True;
    While DelayTimer.Enabled Do
    	Begin
            ClearCommError(hComm,SentOK,nil);
        	Application.ProcessMessages;
        End;
End;
procedure TFormTerm.StayOnTopClick(Sender: TObject);
begin
    myReg.Writebool('StayOnTop',StayOnTop.Checked);
    If(StayOnTop.Checked = true) then
        FormTerm.FormStyle := fsStayOnTop
    else
        FormTerm.FormStyle := fsNormal;
end;

End.

